SystemOrganization addCategory: #'Lumiere-Morphic'!

RectangleMorph subclass: #LumiereMorph
	instanceVariableNames: 'context stage drawable viewport announcer canvas eventHandler stageInteraccion backstage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Lumiere-Morphic'!

!LumiereMorph class methodsFor: 'as yet unclassified' stamp: 'F Olivero 5/12/2009 12:21'!
closeAll
	self allInstances do:[:each| each delete]! !

!LumiereMorph class methodsFor: 'as yet unclassified' stamp: 'F Olivero 5/12/2009 12:28'!
closeLast
	self allInstances last delete! !

!LumiereMorph methodsFor: 'morphic events' stamp: 'FernandoOlivero 9/9/2009 16:45'!
aboutToBeGrabbedBy: hand
	super aboutToBeGrabbedBy: hand.
	! !

!LumiereMorph methodsFor: 'accessing' stamp: 'FernandoOlivero 9/10/2009 07:30'!
acceptDisplayListVisitor
	stage microworld optimizeOn: context .! !

!LumiereMorph methodsFor: 'accessing' stamp: 'FernandoOlivero 9/2/2009 14:53'!
addAxes
	stage addAxes.
	self update.! !

!LumiereMorph methodsFor: 'interaction' stamp: 'F Olivero 7/16/2009 11:45'!
addClickingOnShapes	
	eventHandler 
		handle: #mouseDown;
		on: #mouseDown send:#mouseDown:! !

!LumiereMorph methodsFor: 'accessing' stamp: 'FernandoOlivero 9/2/2009 14:53'!
addDefaultLights
	stage addDefaultLights.
	self update.! !

!LumiereMorph methodsFor: 'interaction' stamp: 'F Olivero 7/23/2009 15:13'!
addFloatingOverAwareness
	eventHandler
		handle: #mouseMove;
		on: #mouseMove send:#mouseMove:. 
	! !

!LumiereMorph methodsFor: 'interaction' stamp: 'F Olivero 8/10/2009 22:20'!
addKeyboardInteraction
	eventHandler
		handle: #keyboard;
		on: #keyStroke send:#keyStroke:.
	stageInteraccion beKeyboardInteraction.! !

!LumiereMorph methodsFor: 'interaction' stamp: 'F Olivero 8/10/2009 12:22'!
addKeyboardNavigation
	eventHandler
		handle: #keyboard;
		on: #keyStroke send:#keyStroke:.
	stageInteraccion beKeyboardNavigation ! !

!LumiereMorph methodsFor: 'accessing' stamp: 'FernandoOlivero 8/26/2009 13:56'!
addLight: aLLight 
	stage addLight: aLLight ! !

!LumiereMorph methodsFor: 'accessing' stamp: 'FernandoOlivero 9/2/2009 18:58'!
addParallelLightDirection: direction  color: color
	stage addParallelLightDirection: direction color: color.
! !

!LumiereMorph methodsFor: 'accessing' stamp: 'FernandoOlivero 10/13/2009 17:11'!
addWindow
	| window |
	window :=  LumiereWindow new.
	window
		drawable: self;
		openInWorld .
	^ window! !

!LumiereMorph methodsFor: 'accessing' stamp: 'FernandoOlivero 8/26/2009 13:56'!
ambientLight: anArray 
	stage ambientLight: anArray ! !

!LumiereMorph methodsFor: 'accessing' stamp: 'FernandoOlivero 8/26/2009 13:56'!
angle: angle aspect: aspect  zNear: znear  zFar: zFar 
	stage viewingVolumeWithAngle: angle aspect: aspect  zNear: znear  zFar: zFar ! !

!LumiereMorph methodsFor: 'interaction' stamp: 'FernandoOlivero 9/13/2009 23:09'!
announceClose
	| ann |
	ann := LStageMorphClose new.
	ann stage: self.
	self announcer announce: ann.! !

!LumiereMorph methodsFor: 'selection/picking' stamp: 'FernandoOlivero 8/26/2009 13:53'!
announceShapeClicked: aLShape
	| announcement |
	announcement := LStageShapeClicked new.
	announcement shape: aLShape; stage: stage.
	self announcer announce: announcement.
! !

!LumiereMorph methodsFor: 'selection/picking' stamp: 'FernandoOlivero 8/26/2009 13:53'!
announceShapeDeletion: aLShape
	| announcement |
	announcement := LStageShapeDeletion new.
	announcement shape: aLShape; stage: stage.
	self announcer announce: announcement.
! !

!LumiereMorph methodsFor: 'selection/picking' stamp: 'FernandoOlivero 8/26/2009 13:53'!
announceShapeDeselection: aLShape
	| announcement |
	announcement := LStageShapeDeselection new.
	announcement shape: aLShape; stage: stage .
	self announcer announce: announcement.
! !

!LumiereMorph methodsFor: 'selection/picking' stamp: 'FernandoOlivero 8/26/2009 13:53'!
announceShapeHighlighted: aLShape
	| announcement |
	announcement := LStageShapeHighlight new.
	announcement shape: aLShape; stage: stage.
	self announcer announce: announcement.
! !

!LumiereMorph methodsFor: 'selection/picking' stamp: 'FernandoOlivero 8/26/2009 13:53'!
announceShapeSelection: aLShape
	| announcement |
	announcement := LStageShapeSelection new.
	announcement shape: aLShape; stage: stage.
	self announcer announce: announcement.
! !

!LumiereMorph methodsFor: 'accessing' stamp: 'F Olivero 5/21/2009 21:28'!
announcer
	^ announcer! !

!LumiereMorph methodsFor: 'accessing' stamp: 'FernandoOlivero 8/31/2009 10:41'!
backgroundColor: aColor
	canvas backgroundColor: aColor .
	! !

!LumiereMorph methodsFor: 'accessing' stamp: 'F Olivero 7/16/2009 11:54'!
backstage
	^ backstage ! !

!LumiereMorph methodsFor: 'interaction' stamp: 'FernandoOlivero 8/26/2009 14:27'!
beFreeMovement
	stage beCameraFreeMovement ! !

!LumiereMorph methodsFor: 'interaction' stamp: 'FernandoOlivero 8/26/2009 14:29'!
beGroundMovement
	stage beCameraGroundMovement ! !

!LumiereMorph methodsFor: 'selection/picking' stamp: 'FernandoOlivero 8/26/2009 13:54'!
beMultipleSelection
	stage beMultipleSelection.
	! !

!LumiereMorph methodsFor: 'selection/picking' stamp: 'FernandoOlivero 8/26/2009 13:54'!
beSingleSelection
	stage beSingleSelection.
	! !

!LumiereMorph methodsFor: 'caching' stamp: 'FernandoOlivero 10/16/2009 11:42'!
cacheMicroworld 
	self stage microworld optimizeOn: canvas! !

!LumiereMorph methodsFor: 'accessing' stamp: 'FernandoOlivero 10/5/2009 11:53'!
camera
	^ stage camera! !

!LumiereMorph methodsFor: 'initialize-release' stamp: 'F Olivero 6/10/2009 16:22'!
canvas
	^ canvas! !

!LumiereMorph methodsFor: 'selection/picking' stamp: 'F Olivero 8/10/2009 22:57'!
clickedShapes: aCollectionOfShapes
	self announceShapeClicked: aCollectionOfShapes first
	! !

!LumiereMorph methodsFor: 'accessing' stamp: 'F Olivero 5/12/2009 11:47'!
context
	^ context! !

!LumiereMorph methodsFor: 'initialize-release' stamp: 'FernandoOlivero 9/13/2009 23:06'!
delete
	context delete.
	stage notNil ifTrue:[ stage delete ].
	drawable close.
	self announceClose.
	super delete
	! !

!LumiereMorph methodsFor: 'caching' stamp: 'FernandoOlivero 10/16/2009 11:41'!
deleteMicroworldCache
	stage microworld notNil ifTrue:[ canvas context deleteCacheOfMicroworld: stage microworld  ]. ! !

!LumiereMorph methodsFor: 'selection/picking' stamp: 'FernandoOlivero 8/26/2009 13:54'!
deleteShapes: aCollectionOfShapes
	stage deleteShapes: aCollectionOfShapes .
	self announceShapeDeletion: aCollectionOfShapes first
	! !

!LumiereMorph methodsFor: 'accessing' stamp: 'F Olivero 7/23/2009 23:31'!
drawable 
	^ drawable ! !

!LumiereMorph methodsFor: 'accessing' stamp: 'F Olivero 7/24/2009 12:17'!
drawableBounds
  ^  bounds origin + 5.0 extent: (bounds extent - 10.0)! !

!LumiereMorph methodsFor: 'morphic events' stamp: 'F Olivero 6/22/2009 11:24'!
eventHandler
	^ eventHandler ! !

!LumiereMorph methodsFor: 'morphic events' stamp: 'F Olivero 7/24/2009 14:32'!
extent: aPoint
	super extent: aPoint.
	self
		updateDrawable;
		updateViewport: (0@0 extent: self drawableBounds extent);
		update! !

!LumiereMorph methodsFor: 'morphic events' stamp: 'FernandoOlivero 10/5/2009 15:29'!
haloDelayTime
	^100! !

!LumiereMorph methodsFor: 'morphic events' stamp: 'F Olivero 7/24/2009 12:25'!
handleMouseMove: anEvent
	"Re-implemented to allow for move without button pressed"
	anEvent wasHandled ifTrue:[^self]. 
	(anEvent hand hasSubmorphs) ifTrue:[^self].
	anEvent wasHandled: true.
	( eventHandler handlesMouseMove: anEvent) ifTrue:[
		anEvent wasHandled: true.
		eventHandler mouseMove: anEvent  fromMorph: self ].! !

!LumiereMorph methodsFor: 'accessing' stamp: 'FernandoOlivero 8/16/2009 22:45'!
hideBackstage
	backstage := nil.
	backstage delete.	! !

!LumiereMorph methodsFor: 'selection/picking' stamp: 'FernandoOlivero 8/26/2009 13:54'!
highlightShapes: aCollectionOfShapes
	aCollectionOfShapes notEmpty
		ifTrue:[ self announceShapeHighlighted: aCollectionOfShapes last]
		ifFalse:[ self announceShapeHighlighted: nil ].
	stage highlightedShapes: aCollectionOfShapes.
	self update! !

!LumiereMorph methodsFor: 'initialize-release' stamp: 'F Olivero 8/15/2009 02:45'!
initialize
	super initialize.
	announcer := Announcer new.
	self
		initializeDrawable;
		initializeLumiere;
		initializeEventHandler.! !

!LumiereMorph methodsFor: 'initialize-release' stamp: 'FernandoOlivero 9/30/2009 21:04'!
initializeDrawable
	drawable := OpenGLSurface newIn: bounds! !

!LumiereMorph methodsFor: 'initialize-release' stamp: 'F Olivero 7/23/2009 15:14'!
initializeEventHandler
	stageInteraccion := LStageInteraccion new.
	stageInteraccion stageMorph: self.
	eventHandler  := LEventHandlerPolicy new.
	eventHandler
		target: stageInteraccion;
		handle:#mouseOver;
		on: #mouseEnter send:#mouseEnter:;
		on: #mouseLeave send:#mouseLeave:.
	! !

!LumiereMorph methodsFor: 'initialize-release' stamp: 'FernandoOlivero 8/26/2009 13:51'!
initializeLumiere 
	viewport := LViewport in: bounds.
	context := LOpenGLContext new.
	context
		view: self;
		color: Color black.
	canvas := LOpenGLCanvas new.
	canvas context: context.
	stage := LStage  new.! !

!LumiereMorph methodsFor: 'testing' stamp: 'F Olivero 7/16/2009 11:57'!
isBackstage
	^ backstage notNil! !

!LumiereMorph methodsFor: 'morphic events' stamp: 'F Olivero 6/15/2009 22:07'!
keyboardFocusChange: aBoolean
	aBoolean ifTrue: [ "gaining keyboard focus"] ifFalse:[ "losing it"]! !

!LumiereMorph methodsFor: 'accessing' stamp: 'F Olivero 5/12/2009 11:47'!
makeCurrent
	drawable makeCurrent! !

!LumiereMorph methodsFor: 'accessing' stamp: 'F Olivero 5/12/2009 11:47'!
maximumOverlappingNamesForPicking
	^ 10! !

!LumiereMorph methodsFor: 'accessing' stamp: 'FernandoOlivero 10/5/2009 18:36'!
microworld
	^ self stage microworld ! !

!LumiereMorph methodsFor: 'accessing' stamp: 'FernandoOlivero 10/16/2009 11:41'!
microworld: aLMicroworld
	self deleteMicroworldCache.
	stage microworld:  aLMicroworld ! !

!LumiereMorph methodsFor: 'morph manipulation' stamp: 'FernandoOlivero 10/15/2009 17:11'!
openCameraMorph
	| dialog |
	dialog := self stage camera asMorph.
	dialog
		position: self position + (self width@0);
		lumiereMorph: self .! !

!LumiereMorph methodsFor: 'morph manipulation' stamp: 'FernandoOlivero 10/18/2009 17:00'!
openLayoutBuilderMorph
	| morph |
	morph := LayoutShapeBuilder new.
	morph
		lumiereMorph: self;
		position: self position + (self width @ 0 ).
	morph open.
	^ morph
	! !

!LumiereMorph methodsFor: 'morph manipulation' stamp: 'FernandoOlivero 10/18/2009 14:13'!
openShapeBuilderMorph
	| morph |
	morph := CompositeShapeBuilder new.
	morph
		lumiereMorph: self;
		position: self position + (self width @ 0 ).
	morph open.
	^ morph
	! !

!LumiereMorph methodsFor: 'morph manipulation' stamp: 'FernandoOlivero 10/13/2009 18:17'!
openViewingVolumeMorph
	| morph |
	morph := stage camera viewingVolume asMorph.
	morph
		position: self position + (self width @ 0 );
		lumiereMorph: self.
	^ morph! !

!LumiereMorph methodsFor: 'morph manipulation' stamp: 'FernandoOlivero 10/13/2009 18:50'!
openViewportMorph
	| morph |
	morph := ViewportMorph new.
	morph
		lumiereMorph: self;
		model: viewport ; 
		position: self position + (self width @ 0 ).
	^ morph
	! !

!LumiereMorph methodsFor: 'accessing' stamp: 'FernandoOlivero 8/26/2009 13:55'!
placeCameraAt: location
	stage placeCameraAt: location ! !

!LumiereMorph methodsFor: 'accessing' stamp: 'FernandoOlivero 8/26/2009 13:55'!
placeCameraAt: location lookingAt: lookAt 
	stage placeCameraAt: location lookingAt: lookAt ! !

!LumiereMorph methodsFor: 'morphic events' stamp: 'F Olivero 7/24/2009 14:32'!
position: aPoint
	super position: aPoint.
	self
		updateDrawable;
		update! !

!LumiereMorph methodsFor: 'interaction' stamp: 'F Olivero 6/15/2009 21:13'!
removeAllInteraccions
	stageInteraccion := nil.
	eventHandler beWithoutInteraccions.! !

!LumiereMorph methodsFor: 'accessing' stamp: 'FernandoOlivero 9/23/2009 13:31'!
removeAxes
	stage removeAxes.
	self update .! !

!LumiereMorph methodsFor: 'interaction' stamp: 'F Olivero 6/15/2009 21:28'!
removeClickingOnShapes	
	eventHandler remove:  #mouseDown! !

!LumiereMorph methodsFor: 'interaction' stamp: 'F Olivero 7/23/2009 21:01'!
removeFloatingOverAwareness
	eventHandler remove: #mouseMove.! !

!LumiereMorph methodsFor: 'interaction' stamp: 'F Olivero 6/15/2009 21:46'!
removeKeyboardNavigation
	eventHandler remove: #keyboard! !

!LumiereMorph methodsFor: 'accessing' stamp: 'FernandoOlivero 8/31/2009 00:29'!
removeWindow
	owner isSystemWindow ifTrue:[ owner removeWindow ].! !

!LumiereMorph methodsFor: 'updating' stamp: 'FernandoOlivero 10/14/2009 11:53'!
renderMicroworld 
	canvas reset.
	canvas drawAViewport .
	stage takePictureOn: canvas.
	drawable update! !

!LumiereMorph methodsFor: 'selection/picking' stamp: 'FernandoOlivero 8/26/2009 13:54'!
selectShapes: aCollectionOfShapes
	| clicked |
	clicked := stage selectedShapes select:[:shape| aCollectionOfShapes includes: shape ].
	clicked notEmpty ifTrue:[ self clickedShapes: clicked ]. 
	stage selectShapes: aCollectionOfShapes.
	aCollectionOfShapes notEmpty ifTrue:[ self announceShapeSelection: aCollectionOfShapes last].
	self update.! !

!LumiereMorph methodsFor: 'accessing' stamp: 'FernandoOlivero 8/31/2009 11:06'!
selectedShapes
	^ stage selectedShapes! !

!LumiereMorph methodsFor: 'updating' stamp: 'F Olivero 7/31/2009 13:48'!
showFocussed 
	self
"		updateViewport: (0@0 extent: self drawableBounds extent);"
		borderWidth: 4.0;
		borderColor: self color muchDarker;
		update.! !

!LumiereMorph methodsFor: 'updating' stamp: 'F Olivero 7/29/2009 13:49'!
showUnfocussed  
	"| extent |
	extent := self bounds extent.
	self
		updateViewport: (extent /4  extent:  extent / 2);"
	self	
		borderWidth: 2.0;
		borderColor: self color muchLighter.
	
	! !

!LumiereMorph methodsFor: 'accessing' stamp: 'FernandoOlivero 8/26/2009 14:25'!
stage 
	^ stage ! !

!LumiereMorph methodsFor: 'accessing' stamp: 'FernandoOlivero 8/26/2009 14:26'!
stage: aLStage 
	stage := aLStage! !

!LumiereMorph methodsFor: 'accessing' stamp: 'F Olivero 7/24/2009 13:41'!
stageInteraccion 
	^ stageInteraccion ! !

!LumiereMorph methodsFor: 'accessing' stamp: 'FernandoOlivero 10/18/2009 17:26'!
toogleAxes
	stage showAxes ifTrue:[ self removeAxes ] ifFalse:[ self addAxes]! !

!LumiereMorph methodsFor: 'selection/picking' stamp: 'F Olivero 7/24/2009 13:10'!
transformGlobalPointToLocal: aPoint
	^ aPoint - bounds origin ! !

!LumiereMorph methodsFor: 'selection/picking' stamp: 'F Olivero 7/24/2009 13:23'!
transformLocalPointToDrawable: aPoint
	^ aPoint - 5.0! !

!LumiereMorph methodsFor: 'accessing' stamp: 'FernandoOlivero 8/26/2009 13:53'!
turnOffLights 
	stage  turnOffLights ! !

!LumiereMorph methodsFor: 'accessing' stamp: 'FernandoOlivero 8/26/2009 13:53'!
turnOnLights 
	stage turnOnLights ! !

!LumiereMorph methodsFor: 'updating' stamp: 'FernandoOlivero 8/26/2009 00:39'!
update
	self renderMicroworld! !

!LumiereMorph methodsFor: 'updating' stamp: 'F Olivero 7/24/2009 14:31'!
updateDrawable 
	drawable bounds: self drawableBounds.
	! !

!LumiereMorph methodsFor: 'updating' stamp: 'FernandoOlivero 10/13/2009 18:31'!
updateViewport
	viewport loadInto: context.
	stage resizeForViewport: viewport.
	self update	! !

!LumiereMorph methodsFor: 'updating' stamp: 'FernandoOlivero 10/13/2009 18:31'!
updateViewport: aRectangle
	viewport x: aRectangle origin x y: aRectangle origin y width: aRectangle width height: aRectangle height.
	self updateViewport.
	! !

!LumiereMorph methodsFor: 'accessing' stamp: 'FernandoOlivero 8/18/2009 00:58'!
viewingVolumeWithAngle: aFloat aspect: aFloat2 zNear: aFloat3 zFar: aFloat4 
	self stage viewingVolumeWithAngle: aFloat aspect: aFloat2 zNear: aFloat3 zFar: aFloat4 ! !

!LumiereMorph methodsFor: 'accessing' stamp: 'F Olivero 5/12/2009 11:47'!
viewport
	^ viewport! !

!LumiereMorph methodsFor: 'morphic events' stamp: 'FernandoOlivero 8/31/2009 11:46'!
wantsHalo
	^ owner isSystemWindow not! !

!LumiereMorph methodsFor: 'accessing' stamp: 'FernandoOlivero 10/5/2009 09:33'!
zNear: aFloat
	self stage camera viewingVolume zNear: aFloat . ! !

Object subclass: #LEventHandlerPolicy
	instanceVariableNames: 'actions events target'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Lumiere-Morphic'!

!LEventHandlerPolicy class methodsFor: 'instance creation' stamp: 'F Olivero 6/15/2009 20:42'!
all
	| handler |
	handler := self new.
	handler 
		handleEvent: #keyboard;
		handleEvent: #mouseDown;
		handleEvent: #mouseOver.
	^ handler! !

!LEventHandlerPolicy methodsFor: 'as yet unclassified' stamp: 'F Olivero 6/15/2009 21:14'!
beWithoutInteraccions
	actions := Dictionary new.
	events := Set new.! !

!LEventHandlerPolicy methodsFor: 'as yet unclassified' stamp: 'F Olivero 7/16/2009 11:42'!
do: eventName event: event 
	| action |
	action :=  actions at: eventName.
	action isNil ifTrue:[ self error ].
	target perform: action  with: event ! !

!LEventHandlerPolicy methodsFor: 'as yet unclassified' stamp: 'F Olivero 6/15/2009 20:40'!
handle: event
	events add: event! !

!LEventHandlerPolicy methodsFor: 'as yet unclassified' stamp: 'F Olivero 6/15/2009 20:39'!
handlesKeyboard: event
	^ events includes: #keyboard! !

!LEventHandlerPolicy methodsFor: 'as yet unclassified' stamp: 'F Olivero 6/15/2009 20:38'!
handlesMouseDown: event
	^ events includes: #mouseDown! !

!LEventHandlerPolicy methodsFor: 'as yet unclassified' stamp: 'F Olivero 7/24/2009 12:26'!
handlesMouseMove: event 
	^ events includes: #mouseMove! !

!LEventHandlerPolicy methodsFor: 'as yet unclassified' stamp: 'F Olivero 6/15/2009 20:38'!
handlesMouseOver: event
	^ events includes: #mouseOver ! !

!LEventHandlerPolicy methodsFor: 'as yet unclassified' stamp: 'F Olivero 6/16/2009 11:18'!
handlesMouseOverDragging: ev
	^events includes: #mouseOverDragging ! !

!LEventHandlerPolicy methodsFor: 'testing' stamp: 'F Olivero 6/22/2009 21:25'!
handlesMouseStillDown: aMouseButtonEvent 
	 ^ events includes: #mouseStillDown! !

!LEventHandlerPolicy methodsFor: 'as yet unclassified' stamp: 'F Olivero 6/15/2009 21:14'!
initialize 
	super initialize.
	self beWithoutInteraccions! !

!LEventHandlerPolicy methodsFor: 'as yet unclassified' stamp: 'F Olivero 6/16/2009 11:36'!
keyStroke: anEvent fromMorph: aLStageMorph 
	self do: #keyStroke event: anEvent ! !

!LEventHandlerPolicy methodsFor: 'as yet unclassified' stamp: 'F Olivero 6/16/2009 11:37'!
mouseDown: evt fromMorph: aLStageMorph
	self do:#mouseDown event: evt! !

!LEventHandlerPolicy methodsFor: 'as yet unclassified' stamp: 'F Olivero 6/16/2009 13:20'!
mouseEnter: event fromMorph: aLStageMorph
	self do:#mouseEnter event: event! !

!LEventHandlerPolicy methodsFor: 'as yet unclassified' stamp: 'F Olivero 6/16/2009 13:48'!
mouseLeave: event fromMorph: aLStageMorph
	self do:#mouseLeave event: event! !

!LEventHandlerPolicy methodsFor: 'as yet unclassified' stamp: 'F Olivero 6/16/2009 11:38'!
mouseMove: event fromMorph: aLStageMorph
		self do:#mouseMove event: event ! !

!LEventHandlerPolicy methodsFor: 'as yet unclassified' stamp: 'F Olivero 6/16/2009 10:54'!
mouseStillDown: event fromMorph: sourceMorph! !

!LEventHandlerPolicy methodsFor: 'as yet unclassified' stamp: 'F Olivero 6/22/2009 21:26'!
mouseUp: aMouseButtonEvent fromMorph: aLStageMorph 
	
	! !

!LEventHandlerPolicy methodsFor: 'as yet unclassified' stamp: 'F Olivero 7/16/2009 11:41'!
on: event send: message
	actions at: event put: message.! !

!LEventHandlerPolicy methodsFor: 'as yet unclassified' stamp: 'F Olivero 6/15/2009 21:24'!
remove: event
	events remove: event ifAbsent: [].
	actions removeKey: event ifAbsent:[]! !

!LEventHandlerPolicy methodsFor: 'as yet unclassified' stamp: 'F Olivero 7/16/2009 20:40'!
target: anObject
	target := anObject ! !

Object subclass: #LStageInteraccion
	instanceVariableNames: 'stageMorph backgroundColor pickingVisitor keyboardInteracctionPolicy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Lumiere-Morphic'!

!LStageInteraccion methodsFor: 'accessing' stamp: 'F Olivero 8/10/2009 12:23'!
beKeyboardInteraction
	keyboardInteracctionPolicy := LStageKeyboardInteraccionPolicy keyboardSceneTraversal.
	keyboardInteracctionPolicy stageInteraccion: self.! !

!LStageInteraccion methodsFor: 'accessing' stamp: 'F Olivero 8/10/2009 11:12'!
beKeyboardNavigation
	keyboardInteracctionPolicy := LStageKeyboardInteraccionPolicy keyboardNavigation.
	keyboardInteracctionPolicy stageInteraccion: self.! !

!LStageInteraccion methodsFor: 'scene traversal' stamp: 'F Olivero 8/11/2009 00:14'!
deletePressed
	 stageMorph deleteShapes: stageMorph stage selectedShapes. ! !

!LStageInteraccion methodsFor: 'scene traversal' stamp: 'FernandoOlivero 8/28/2009 12:22'!
downKeyPressed
	| shape node group  previous groupParent selected |
	stageMorph selectedShapes isEmpty ifTrue:[ ^ self ].	
	shape := stageMorph selectedShapes first.
	node := shape node. 
	group := node parent.
	[ group isNil or:[ group isGroupNode  ] ] whileFalse:[ group := group parent ].
	group isNil ifTrue:[ ^ self ].
	previous := group previousGroupNodeChild.
	previous isNil ifTrue:[ ^ nil ].
	groupParent := previous parent.
	selected := groupParent previousDrawableNodeOf: previous.
	selected notNil ifTrue:[ stageMorph stage selectShapes: { selected shape   } ].
	! !

!LStageInteraccion methodsFor: 'scene traversal' stamp: 'F Olivero 8/11/2009 00:13'!
enterPressed
	 stageMorph clickedShapes: stageMorph stage selectedShapes. ! !

!LStageInteraccion methodsFor: 'inputs' stamp: 'F Olivero 8/10/2009 11:11'!
keyStroke: evt 
	keyboardInteracctionPolicy keyStroke: evt.
	self update ! !

!LStageInteraccion methodsFor: 'scene traversal' stamp: 'FernandoOlivero 8/28/2009 12:26'!
leftKeyPressed
	| node previous |
	stageMorph selectedShapes isEmpty ifTrue:[ ^ self ].
	node := ( stageMorph selectedShapes first ) node.
	previous := node previousDrawableNode.
	previous notNil ifTrue:[ stageMorph stage selectShapes: { previous shape   } ].
	! !

!LStageInteraccion methodsFor: 'inputs' stamp: 'FernandoOlivero 8/28/2009 12:22'!
mouseDown: anEvent
	| pickedShapes |
	self stage microworld isNil ifTrue:[ ^ self ].
	pickedShapes := self pickAllNamesUnder: anEvent position.
	stageMorph selectShapes: pickedShapes.
	
! !

!LStageInteraccion methodsFor: 'inputs' stamp: 'F Olivero 7/23/2009 21:50'!
mouseEnter: anEvent
"
	Transcript show: #entered;cr.
"
	stageMorph
		takeKeyboardFocus;
		showFocussed	! !

!LStageInteraccion methodsFor: 'inputs' stamp: 'F Olivero 7/23/2009 21:50'!
mouseLeave: anEvent
"
	Transcript show: #entered;cr.
"
	stageMorph activeHand newKeyboardFocus: nil.
	stageMorph showUnfocussed ! !

!LStageInteraccion methodsFor: 'inputs' stamp: 'FernandoOlivero 8/28/2009 12:15'!
mouseMove: anEvent
	| pickedShapes |
	self stage microworld isNil ifTrue:[ ^ self ].
	pickedShapes := self pickAllNamesUnder: anEvent position.
	stageMorph  highlightShapes: pickedShapes.! !

!LStageInteraccion methodsFor: 'selection/picking' stamp: 'FernandoOlivero 10/5/2009 09:32'!
pickAllNamesUnder: aMorphicPoint
	|selectionBufferSize selectBuffer  openglPoint error hits pickedShapes stage |
	openglPoint := self transformGlobalPointToLocal: aMorphicPoint.
	stage := stageMorph stage.
	selectionBufferSize := 200.
	selectBuffer := stageMorph context createAndLoadSelectionBufferSized: selectionBufferSize.
	pickingVisitor prunedNodes: #().
	error := false. 
	[hits := stageMorph context 
		inSelectRenderModeDo: [:anOglContext|
			anOglContext 
				loadProjectionMode;
				clearTransformation;
				loadPickMatrixUnder: openglPoint
				tolerance: 1
				viewport: stageMorph viewport asArray.
			stage camera  loadProjectionInto: anOglContext.
			anOglContext 
				loadModelViewMode;
				clearTransformation.
			stage camera loadModelViewInto: anOglContext.
			stageMorph canvas beForPicking.
			pickingVisitor traverse: stage microworld andRenderOn: stageMorph canvas ].
		] on: Error do:[:err| error := true. Transcript show:'Selection buffer has not enough space!!'. err pass ].
	pickedShapes := OrderedCollection new.
	(error not and: [hits > 0])
		ifTrue:[
			|pickedSceneNode|
			pickedSceneNode := pickingVisitor nodeNamed: (selectBuffer lastNamedPickedFor: hits).
			pickedShapes add: pickedSceneNode shape ].
	selectBuffer delete.
	^ pickedShapes	! !

!LStageInteraccion methodsFor: 'private' stamp: 'F Olivero 7/24/2009 16:11'!
removeHighlight
	! !

!LStageInteraccion methodsFor: 'scene traversal' stamp: 'FernandoOlivero 8/28/2009 12:25'!
rightKeyPressed
	| node next |
	stageMorph selectedShapes isEmpty ifTrue:[ ^ self ].	
	node := (stageMorph selectedShapes first) node.
	next := node nextDrawableNode.
	next notNil ifTrue:[ stageMorph stage selectShapes: { next shape }]! !

!LStageInteraccion methodsFor: 'accessing' stamp: 'F Olivero 8/11/2009 22:37'!
stage
	^ stageMorph stage! !

!LStageInteraccion methodsFor: 'accessing' stamp: 'F Olivero 7/24/2009 12:29'!
stageMorph: aLStageMorph
	stageMorph := aLStageMorph.
	backgroundColor := stageMorph canvas backgroundColor.
	pickingVisitor := LScenePickingVisitor new.! !

!LStageInteraccion methodsFor: 'private' stamp: 'F Olivero 7/24/2009 13:34'!
transformGlobalPointToLocal: aMorphicPoint
	| stageMorphPoint drawablePoint openglPoint |
	stageMorphPoint := stageMorph transformGlobalPointToLocal: aMorphicPoint.
	drawablePoint := stageMorph transformLocalPointToDrawable: stageMorphPoint.
	openglPoint :=  drawablePoint x @ ( stageMorph viewport height - drawablePoint y + stageMorph viewport y).
	^ openglPoint! !

!LStageInteraccion methodsFor: 'scene traversal' stamp: 'FernandoOlivero 8/28/2009 12:23'!
upKeyPressed
	| node group  previous groupParent selected|
	stageMorph selectedShapes isEmpty ifTrue:[ ^ self ].	
	node := (stageMorph selectedShapes first) node.
	group := node parent.
	[ group isNil or:[ group isGroupNode  ] ] whileFalse:[ group := group parent ].
	group isNil ifTrue:[ ^ self ].
	previous := group previousGroupNodeChild.
	previous isNil ifTrue:[ ^ self ].
	groupParent := previous parent.
	selected := groupParent nextDrawableNodeOf: previous.
	selected notNil ifTrue:[ stageMorph stage selectShapes: { selected  shape  } ].
	! !

!LStageInteraccion methodsFor: 'private' stamp: 'F Olivero 7/23/2009 15:33'!
update
	
	stageMorph update! !

Object subclass: #LStageKeyboardInteraccionPolicy
	instanceVariableNames: 'stageInteraccion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Lumiere-Morphic'!

LStageKeyboardInteraccionPolicy subclass: #LStageKeyboardCameraNavigation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Lumiere-Morphic'!

!LStageKeyboardCameraNavigation methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/11/2009 15:40'!
keyStroke: evt 
	| movementPolicy  |
	movementPolicy := stageInteraccion  stage camera  movementPolicy.
	
	evt keyCharacter == Character space ifTrue:[ movementPolicy toogleSpeed].
	
	evt keyCharacter == Character arrowDown ifTrue:[ movementPolicy backwardKeyPressed  ].
	evt keyCharacter == Character arrowUp ifTrue:[ movementPolicy forwardKeyPressed ].
	evt keyCharacter == Character arrowLeft ifTrue:[ movementPolicy leftKeyPressed ].	
	evt keyCharacter == Character arrowRight ifTrue:[ movementPolicy rightKeyPressed ].

	evt keyCharacter == $w ifTrue:[ movementPolicy upKeyPressed  ]. 
	evt keyCharacter == $s ifTrue:[ movementPolicy downKeyPressed ].
	evt keyCharacter == $q ifTrue:[ movementPolicy pitchUpKeyPressed ].
	evt keyCharacter == $a ifTrue:[ movementPolicy pitchDownKeyPressed ].
	evt keyCharacter == $e ifTrue:[ movementPolicy yawRightKeyPressed ].
	evt keyCharacter == $d ifTrue:[ movementPolicy  yawLeftKeyPressed ].
	evt keyCharacter == $r ifTrue:[ movementPolicy rollRightKeyPressed ].
	evt keyCharacter == $f ifTrue:[ movementPolicy  rollLeftKeyPressed ].! !

!LStageKeyboardInteraccionPolicy class methodsFor: 'as yet unclassified' stamp: 'F Olivero 8/10/2009 11:16'!
keyboardNavigation 
	^ LStageKeyboardCameraNavigation new! !

!LStageKeyboardInteraccionPolicy class methodsFor: 'as yet unclassified' stamp: 'F Olivero 8/10/2009 11:16'!
keyboardSceneTraversal
	^ LStageKeyboardSceneTraversal new! !

!LStageKeyboardInteraccionPolicy methodsFor: 'as yet unclassified' stamp: 'F Olivero 8/10/2009 11:14'!
keyStroke: evt 
	self subclassResponsibility ! !

!LStageKeyboardInteraccionPolicy methodsFor: 'as yet unclassified' stamp: 'F Olivero 8/10/2009 11:13'!
stageInteraccion: aLStageInteraccion
	stageInteraccion := aLStageInteraccion! !

LStageKeyboardInteraccionPolicy subclass: #LStageKeyboardSceneTraversal
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Lumiere-Morphic'!

!LStageKeyboardSceneTraversal methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 8/16/2009 23:49'!
keyStroke: evt 
	stageInteraccion  stage selectedShapes isEmpty ifTrue:[ stageInteraccion  stage selectFirstShape].
	evt keyCharacter == Character arrowDown ifTrue:[ ^ stageInteraccion  downKeyPressed   ].
	evt keyCharacter == Character arrowUp ifTrue:[ ^ stageInteraccion upKeyPressed ].
	evt keyCharacter == Character arrowLeft ifTrue:[ ^ stageInteraccion leftKeyPressed ].	
	evt keyCharacter == Character arrowRight ifTrue:[ ^ stageInteraccion rightKeyPressed ].
	evt keyCharacter == Character space ifTrue:[ ^ stageInteraccion enterPressed ].
	evt keyCharacter == Character backspace ifTrue:[ ^ stageInteraccion deletePressed ].
	

	! !

Object subclass: #LStageManipulationMorph
	instanceVariableNames: 'model lumiereMorph dialog'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Lumiere-Morphic'!

LStageManipulationMorph class
	instanceVariableNames: 'dialog'!

LStageManipulationMorph class
	instanceVariableNames: 'dialog'!

LStageManipulationMorph subclass: #CameraMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Lumiere-Morphic'!

!CameraMorph methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/18/2009 12:11'!
updateView
	| builder morph  m |
	builder := ExampleBuilderMorph new.
	dialog := (builder newPluggableDialogWindow: 'Camera') useDefaultOKButton .
	morph := dialog newColumn:{ 
		dialog newColumn:{ 
			dialog newLabel:'Location'.
			UpdatingStringMorph on: model selector: #location }.
		dialog newSeparator.
		dialog newColumn:{ 
			dialog newLabel:'LookAt'.
			UpdatingStringMorph on: model selector: #lookAt }.
		dialog newSeparator.
		dialog newColumn:{ 
			dialog newLabel:'Up'.
			UpdatingStringMorph on: model selector: #up }}.	
	dialog
		contentMorph: morph;
		applyChangesSelector: (lumiereMorph notNil ifTrue:[#update] ifFalse:[nil]);
		model: lumiereMorph.
	m := builder openModal: dialog.
	m extent: 400@300.
	^ m
	
	
	! !

LStageManipulationMorph subclass: #CompositeShapeBuilder
	instanceVariableNames: 'translation rotation shapeChooser colorMorph units'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Lumiere-Morphic'!

!CompositeShapeBuilder methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/18/2009 21:19'!
addShape
	units timesRepeat: [model 	
			addChild: self shape 
			at:  translation
			rotatedBy:  rotation ].
	self updateLumiereMorph ! !

!CompositeShapeBuilder methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/18/2009 21:18'!
createSubmorphs  
	| builder morph  buttons spec |
	builder := ExampleBuilderMorph new.
	dialog := builder newDialogPanel. 
	shapeChooser := ShapeChooser new.
	colorMorph := VectorColorMorph on: {1.0. 1.0. 1.0. 1.0}.
	spec := builder newColumn:{
			builder newRow: {builder newLabel: 'color'. colorMorph dialog}.		
			builder newRow: {builder newLabel: 'at'. (Vector3DMorph on: translation) dialog  }.
			builder newRow: {builder 
				newLabel: 'rotated by'. (RotationVectorMorph on: rotation) dialog }}.
	spec vResizing: #spaceFill.			
	buttons :=  builder newColumn: {
		builder newRow:{ builder newLabel: '#'. builder newTextEntryFor: self get:#unitsToAdd  set:#unitsToAdd: class: Integer  getEnabled: nil  help:'Numbero of selected shapes to add' }.
		builder newButtonFor: self action: #addShape label: '+' help:'Add selected shape'.
		builder  newButtonFor: self action:#resetModel label:'Remove All'  help:'Start with an empty composite shape'}.
	buttons vResizing: #spaceFill.			
	morph := builder newRow:{ 
			shapeChooser dialog.
			builder newVerticalSeparator.
			spec.
			builder  newVerticalSeparator.
			buttons  }.	
	morph 
		vResizing: #spaceFill.
	dialog addMorphBack: morph.
	
	! !

!CompositeShapeBuilder methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/18/2009 20:11'!
initialize 
	super initialize .
	translation := {0.0. 0.0. 0.0}.
	rotation := {0.0. 0.0. 0.0. 0.0}.
	model := LCompositeShape new.
	units := 1.
	self createSubmorphs.! !

!CompositeShapeBuilder methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/18/2009 21:16'!
open
	| m |
	m := dialog embeddedInMorphicWindowLabeled: 'CompositeShapeBuilder' .
	m extent: 600@250;openInWorld .
	^ m
	! !

!CompositeShapeBuilder methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/18/2009 14:18'!
resetModel
	model := LCompositeShape new.
	self updateLumiereMorph.! !

!CompositeShapeBuilder methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/18/2009 14:46'!
rotation 
	^ rotation ! !

!CompositeShapeBuilder methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/18/2009 14:50'!
shape
	shape := shapeChooser shape.
	shape color: colorMorph color.
	^ shape! !

!CompositeShapeBuilder methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/18/2009 14:46'!
translation 
	^ translation ! !

!CompositeShapeBuilder methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/18/2009 13:36'!
unitsToAdd
	^ units! !

!CompositeShapeBuilder methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/18/2009 17:29'!
unitsToAdd: anInteger 
	units := anInteger.
	^ true  ! !

!CompositeShapeBuilder methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/18/2009 14:18'!
updateLumiereMorph
	lumiereMorph notNil ifTrue:[
		lumiereMorph
			microworld: model asMicroworld; 
			update ].	 ! !

!LStageManipulationMorph class methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/13/2009 18:46'!
on: object
	| morph |
	morph := self new.
	morph model: object.
	^ morph! !

!LStageManipulationMorph methodsFor: 'accessing' stamp: 'FernandoOlivero 10/14/2009 12:10'!
delete
	dialog delete ! !

!LStageManipulationMorph methodsFor: 'accessing' stamp: 'FernandoOlivero 10/18/2009 13:15'!
dialog 
	^ dialog ! !

!LStageManipulationMorph methodsFor: 'accessing' stamp: 'FernandoOlivero 10/13/2009 18:19'!
lumiereMorph
	^ lumiereMorph! !

!LStageManipulationMorph methodsFor: 'accessing' stamp: 'FernandoOlivero 10/13/2009 18:19'!
lumiereMorph: anObject
	lumiereMorph := anObject! !

!LStageManipulationMorph methodsFor: 'accessing' stamp: 'FernandoOlivero 10/13/2009 18:19'!
model
	^ model! !

!LStageManipulationMorph methodsFor: 'accessing' stamp: 'FernandoOlivero 10/13/2009 18:20'!
model: aLViewingVolume
	model = aLViewingVolume ifTrue:[ ^ self].
	model := aLViewingVolume. 
	self updateView .	
	
	 ! !

!LStageManipulationMorph methodsFor: 'accessing' stamp: 'FernandoOlivero 10/13/2009 18:20'!
position: aPoint 
	dialog position: aPoint ! !

LStageManipulationMorph subclass: #LayoutShapeBuilder
	instanceVariableNames: 'listModel runButton layoutChooser radiusEntry radius gap scale'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Lumiere-Morphic'!

!LayoutShapeBuilder methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/18/2009 21:10'!
createSubmorphs  
	| builder morph  buttons spec gapEntry scaleEntry  |
	builder := ExampleBuilderMorph new.
	dialog := builder newDialogPanel.
	layoutChooser := self layoutChooser.
	gapEntry := builder newTextEntryFor: self  get:#gap set:#gap: class: Float getEnabled: nil help:'...'.
	scaleEntry := builder newTextEntryFor: self  get:#scale set:#scale: class: Float getEnabled: nil help:'...'.
	radiusEntry := builder newTextEntryFor: self  get:#radius set:#radius: class: Float getEnabled:#isPolarLayout help:'...'.
	spec := builder newColumn:{
			builder newRow: {builder newLabel: 'Gap'. gapEntry }.
			builder newRow: {builder newLabel: 'Scale'. scaleEntry}.
			builder newRow: {builder newLabel: 'Radius'. radiusEntry }}.
	spec vResizing: #spaceFill.			
	runButton := builder
			newButtonFor: self
			getState: nil	
			action: #run
			arguments: nil
			getEnabled: #hasLayout
			label: 'Run'
			help:'Apply layout to micorworld shapes' .
	buttons :=  builder newColumn: { runButton}.
	buttons vResizing: #spaceFill.			
	morph := builder newRow:{ 
			layoutChooser.
			builder newVerticalSeparator.
			spec.
			builder  newVerticalSeparator.
			buttons  }.	
	morph 
		vResizing: #spaceFill.
	dialog addMorphBack: morph! !

!LayoutShapeBuilder methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/18/2009 20:45'!
gap  
 	^ gap ! !

!LayoutShapeBuilder methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/18/2009 21:19'!
gap: float  
 	gap := float.
	^ true! !

!LayoutShapeBuilder methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/18/2009 17:34'!
hasLayout
	^ listModel selectedItem notNil! !

!LayoutShapeBuilder methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/18/2009 20:46'!
initialize 
	super initialize .
	gap := 1.0.
	scale := {1.0. 1.0. 1.0}.
	radius := 6.0.
	self createSubmorphs.! !

!LayoutShapeBuilder methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/18/2009 20:47'!
isPolarLayout 
	^ self hasLayout and:[ listModel selectedItem contents ='LPolarLayout' ]! !

!LayoutShapeBuilder methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/18/2009 20:45'!
layout
	| cls layout selectedClass |
	selectedClass := listModel selectedItem.
	cls := Smalltalk at: selectedClass contents asSymbol. 
	layout := cls new.
	layout
		scale:  scale;
		gap:  gap.
	layout isPolarLayout ifTrue:[ layout radius: radius ].
	^ layout	! !

!LayoutShapeBuilder methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/18/2009 20:34'!
layoutChooser
	| strings builder chooser sorted |
	listModel := ListModel new.
	sorted := SortedCollection sortBlock:[:a :b| a name < b name].
	sorted addAll: LumiereLayout availableLayouts .
	strings := sorted collect:[:symbol| StringMorph contents: symbol asString].
	listModel
		list: strings;
		selectionIndex: (listModel list indexOf: model).
	builder := ExampleBuilderMorph new.
	chooser := builder
		newMorphListFor: self   
		list: #layoutList 
		getSelected: #selectionLayoutIndex
		setSelected: #selectionLayoutIndex:
		help: '...'.
	chooser
		vResizing: #spaceFill;
		hResizing: #spaceFill;
		extent: 400@400.
	^ chooser		! !

!LayoutShapeBuilder methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/18/2009 17:36'!
layoutList
	^ listModel list! !

!LayoutShapeBuilder methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/18/2009 21:16'!
open
	| m |
	m := dialog embeddedInMorphicWindowLabeled: 'LayoutShapeBuilder' .
	m extent: 600@150;openInWorld .
	^ m
	! !

!LayoutShapeBuilder methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/18/2009 20:43'!
radius
	^ radius! !

!LayoutShapeBuilder methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/18/2009 21:19'!
radius: float  
 	radius := float.
	^ true! !

!LayoutShapeBuilder methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/18/2009 20:45'!
run
	| layout |
	lumiereMorph notNil ifFalse:[ ^ self ].
	layout := self layout.
	layout
		shapes: lumiereMorph microworld firstLevelShapes;
		run.
	lumiereMorph
		microworld: layout asMicroworld;
		update.
	! !

!LayoutShapeBuilder methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/18/2009 20:45'!
scale 
 	^ scale ! !

!LayoutShapeBuilder methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/18/2009 21:19'!
scale: float  
 	scale := float.
	^ true! !

!LayoutShapeBuilder methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/18/2009 17:36'!
selectionLayoutIndex
	^ listModel selectionIndex! !

!LayoutShapeBuilder methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/18/2009 20:36'!
selectionLayoutIndex: i 
	listModel selectionIndex: i.
	self updateView 
	! !

!LayoutShapeBuilder methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/18/2009 20:41'!
updateView
	runButton update:#hasLayout.
	layoutChooser update:#selectionLayoutIndex.
	radiusEntry update:#isPolarLayout.! !

LStageManipulationMorph subclass: #ShapeChooser
	instanceVariableNames: 'listModel listMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Lumiere-Morphic'!

!ShapeChooser methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/18/2009 14:55'!
createSubmorphs 
	| builder |
	builder := ExampleBuilderMorph new.
	dialog := builder
		newMorphListFor: listModel
		list: #list
		getSelected: #selectionIndex
		setSelected: #selectionIndex:
		help: '...'.
	dialog
		vResizing: #spaceFill;
		hResizing: #spaceFill;
		extent: 400@400! !

!ShapeChooser methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/18/2009 14:53'!
initialize 
	super initialize .
	self initializeShapesList.
	self createSubmorphs ! !

!ShapeChooser methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/18/2009 13:02'!
initializeShapesList
	| strings |
	listModel := ListModel new.
	strings := LShape availableShapes
		collect:[:symbol| StringMorph contents: symbol asString].
	listModel
		list: strings;
		selectionIndex: 1.
		! !

!ShapeChooser methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/18/2009 14:54'!
open
	dialog openInWorld 					! !

!ShapeChooser methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/18/2009 14:46'!
shape
	| selector shape |
	selector := (listModel selectedItem) contents. 
	shape := LShape perform: selector asSymbol.
	^ shape! !

LStageManipulationMorph subclass: #Vector3DMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Lumiere-Morphic'!

Vector3DMorph subclass: #RotationVectorMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Lumiere-Morphic'!

!RotationVectorMorph methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/18/2009 12:48'!
angle
	^ model first! !

!RotationVectorMorph methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/18/2009 12:48'!
angle: float 
	model at: 1 put: float.
	^ true! !

!RotationVectorMorph methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/18/2009 12:50'!
offset 
	^ 1! !

!RotationVectorMorph methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/18/2009 13:17'!
updateView
	| builder |
	builder := ExampleBuilderMorph new.
	dialog := builder newRow:{ 
		builder newRow:{
			builder newLabel: 'angle'.
			builder newTextEntryFor: self get: #angle set: #angle: class: Float getEnabled: nil help:'...' }. 	
		builder newRow:{
			builder newLabel: 'x'.
			builder newTextEntryFor: self get: #x set: #x: class: Float getEnabled: nil help:'...' }. 		builder newRow:{
			builder newLabel: 'y'.
			builder newTextEntryFor: self get: #y set: #y: class: Float getEnabled: nil help:'...' }. 		builder newRow:{
			builder newLabel: 'z'.
			builder newTextEntryFor: self get: #z set: #z: class: Float getEnabled: nil help:'...' }}. 	
	dialog extent: 250@100.
	dialog openInWorld
	

! !

!Vector3DMorph methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/18/2009 12:50'!
offset 
	^ 0! !

!Vector3DMorph methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/18/2009 13:18'!
updateView
	| builder |
	builder := ExampleBuilderMorph new.
	dialog := builder newRow:{ 
		builder newRow:{
			builder newLabel: 'x'.
			builder newTextEntryFor: self get: #x set: #x: class: Float getEnabled: nil help:'...' }. 		builder newRow:{
			builder newLabel: 'y'.
			builder newTextEntryFor: self get: #y set: #y: class: Float getEnabled: nil help:'...' }. 		builder newRow:{
			builder newLabel: 'z'.
			builder newTextEntryFor: self get: #z set: #z: class: Float getEnabled: nil help:'...' }}. 	
	dialog extent: 200@100.
	dialog openInWorld
	
! !

!Vector3DMorph methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/18/2009 12:49'!
x
	^ model at: 1 + self offset ! !

!Vector3DMorph methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/18/2009 12:49'!
x: number 
	model at: 1 + self offset put: number.
	^ true! !

!Vector3DMorph methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/18/2009 12:49'!
y 
	^ model at: 2 + self offset! !

!Vector3DMorph methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/18/2009 12:49'!
y: number 
	model at: 2 + self offset put: number.
	^ true	! !

!Vector3DMorph methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/18/2009 12:49'!
z 
	^ model at: 3 + self offset! !

!Vector3DMorph methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/18/2009 12:50'!
z: number 
	model at: 3 + self offset put: number .
	^ true	! !

LStageManipulationMorph subclass: #VectorColorMorph
	instanceVariableNames: 'rEntry gEntry bEntry aEntry'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Lumiere-Morphic'!

!VectorColorMorph methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/18/2009 13:11'!
a 
	^ model fourth ! !

!VectorColorMorph methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/18/2009 13:11'!
a: float
	model at: 4 put: float.
	^ true! !

!VectorColorMorph methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/18/2009 13:11'!
b
	^ model third! !

!VectorColorMorph methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/18/2009 13:10'!
b: float
	model at: 3 put: float.
	^ true! !

!VectorColorMorph methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/18/2009 13:51'!
color
	^ Color fromArray: model 
		 ! !

!VectorColorMorph methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/18/2009 14:35'!
color: aColor 
	self model: {aColor red. aColor green. aColor blue. aColor alpha}.
! !

!VectorColorMorph methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/18/2009 14:39'!
createSubmorphs  
	| builder |
	dialog  notNil ifTrue:[ dialog delete].
	builder := ExampleBuilderMorph new.
	rEntry := builder newTextEntryFor: self get: #r set: #r: class: Float getEnabled: nil help:'...'.
	gEntry := builder newTextEntryFor: self get: #g set: #g: class: Float getEnabled: nil help:'...' .
	bEntry := builder newTextEntryFor: self get: #b set: #b: class: Float getEnabled: nil help:'...' .
	aEntry := builder newTextEntryFor: self get: #a set: #a: class: Float getEnabled: nil help:'...' .
	dialog := builder newRow:{ 
			builder newRow:{ builder newLabel: 'r'. rEntry }. 		
			builder newRow:{ builder newLabel: 'g'. gEntry }.
			builder newRow:{builder newLabel: 'b'. bEntry }.
			builder newRow:{ builder newLabel: 'a'. aEntry}.
		builder newColorChooserFor: self getColor:#color setColor:#color: help:'...'.}. 	
	dialog extent: 250@100.

	
! !

!VectorColorMorph methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/18/2009 13:11'!
g 
	^ model second ! !

!VectorColorMorph methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/18/2009 13:10'!
g: float
	model at: 2 put: float.
	^ true! !

!VectorColorMorph methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/18/2009 14:41'!
initialize 
	super initialize .
	model := {1.0. 1.0. 1.0. 1.0}.
	self createSubmorphs ! !

!VectorColorMorph methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/18/2009 14:39'!
open
	dialog openInWorld! !

!VectorColorMorph methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/18/2009 13:12'!
r 
	^ model first ! !

!VectorColorMorph methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/18/2009 13:44'!
r: float
	model at: 1 put: float.
	^ true
	! !

!VectorColorMorph methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/18/2009 14:41'!
updateView 
	rEntry update:#r.
	gEntry update:#g.
	bEntry update:#b.
	aEntry update:#a
! !

LStageManipulationMorph subclass: #ViewingVolumeMorph
	instanceVariableNames: 'info'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Lumiere-Morphic'!

!ViewingVolumeMorph methodsFor: 'accessing' stamp: 'FernandoOlivero 10/18/2009 21:23'!
angle
	^ model angle! !

!ViewingVolumeMorph methodsFor: 'accessing' stamp: 'FernandoOlivero 10/18/2009 21:23'!
angle: float 
	model angle: float.
	self updateLumiereMorph ! !

!ViewingVolumeMorph methodsFor: 'accessing' stamp: 'FernandoOlivero 10/18/2009 21:24'!
aspect 
	^ model aspect ! !

!ViewingVolumeMorph methodsFor: 'accessing' stamp: 'FernandoOlivero 10/18/2009 21:25'!
aspect: float 
	model aspect: float.
	self updateLumiereMorph ! !

!ViewingVolumeMorph methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/18/2009 21:28'!
updateLumiereMorph 
	lumiereMorph notNil ifTrue:[lumiereMorph update].
	info contents: model printString . ! !

!ViewingVolumeMorph methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/18/2009 21:27'!
updateView
	| builder morph  m |
	builder := ExampleBuilderMorph new.
	dialog := (builder newPluggableDialogWindow: 'Viewing Volume ') useDefaultOKButton .	info := dialog newLabel: model printString.
	morph := dialog newColumn:{ 
		info .
		dialog newSeparator.
		dialog newLabelGroup:{
		'Angle' -> (dialog
							newSliderFor: self  
								getValue: #angle
								setValue: #angle: 
								min: 0.0
								max: 180.0
								quantum: 1.0
								getEnabled: nil
								help: '0.0...180.0') .
		'Aspect' -> (dialog
							newSliderFor: self  
								getValue: #aspect
								setValue: #aspect: 
								help: '0.0...1.0').
		'Z near' -> (dialog
							newSliderFor: self 
								getValue: #zNear
								setValue: #zNear:
								min: 0.0
								max: 10 
								quantum: 0.1
								getEnabled: nil 
								help: '0.0...10').
		'Z far' -> (dialog
							newSliderFor: self 
								getValue: #zFar
								setValue: #zFar:
								min: 0.0
								max: 5000  
								quantum: 1.0
								getEnabled: nil 
								help: '0.0...5000').
								 }.
								}.	
	dialog
		contentMorph: morph;
		applyChangesSelector: (lumiereMorph notNil ifTrue:[#update] ifFalse:[nil]);
		model: lumiereMorph.
	m := builder openModal: dialog.
	^ m
	
	
	! !

!ViewingVolumeMorph methodsFor: 'accessing' stamp: 'FernandoOlivero 10/18/2009 21:24'!
zFar 
	^ model zFar! !

!ViewingVolumeMorph methodsFor: 'accessing' stamp: 'FernandoOlivero 10/18/2009 21:25'!
zFar: float 
	model zFar: float.
	self updateLumiereMorph ! !

!ViewingVolumeMorph methodsFor: 'accessing' stamp: 'FernandoOlivero 10/18/2009 21:24'!
zNear
	^ model zNear ! !

!ViewingVolumeMorph methodsFor: 'accessing' stamp: 'FernandoOlivero 10/18/2009 21:25'!
zNear: float 
	model zNear: float.
	self updateLumiereMorph ! !

LStageManipulationMorph subclass: #ViewportMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Lumiere-Morphic'!

!ViewportMorph methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/14/2009 12:14'!
updateView
	| builder morph  m maxWidth maxHeight |
	maxWidth :=  lumiereMorph width.
	maxHeight :=  lumiereMorph width.
	builder := ExampleBuilderMorph new.
	dialog := (builder newPluggableDialogWindow: 'Viewport') useDefaultOKButton .
	morph := dialog newColumn:{ 
		dialog newLabel: model printString.
		dialog newSeparator.
		dialog newLabelGroup:{
		'x' -> (dialog
							newSliderFor: model 
								getValue: #x
								setValue: #x: 
								min: 0.0
								max: maxWidth 
								quantum: 1.0
								getEnabled: nil
								help: '0.0...', maxWidth asString) .
		'y' -> (dialog
							newSliderFor: model 
								getValue: #y
								setValue: #y: 
								min: 0.0
								max: maxHeight 
								quantum: 1.0
								getEnabled: nil
								help: '0.0...', maxHeight asString) .
		'width' -> (dialog
							newSliderFor: model 
								getValue: #width
								setValue: #width: 
								min: 0.0
								max: maxWidth 
								quantum: 1.0
								getEnabled: nil
								help: '0.0...', maxWidth asString) .
			'height' -> (dialog
							newSliderFor: model 
								getValue: #height
								setValue: #height: 
								min: 0.0
								max: maxHeight 
								quantum: 1.0
								getEnabled: nil
								help: '0.0...', maxHeight asString) .					
		}.
								}.	
	dialog
		contentMorph: morph;
		applyChangesSelector: (lumiereMorph notNil ifTrue:[#updateViewport] ifFalse:[nil]);
		model: lumiereMorph.
	m := builder openModal: dialog.
	^ m
	
	
	! !

StandardWindow subclass: #LumiereWindow
	instanceVariableNames: 'context stage drawable viewport pickingVisitor canvas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Lumiere-Morphic'!

!LumiereWindow class methodsFor: 'accessing' stamp: 'F Olivero 4/3/2009 15:14'!
closeAllWindows
"
self closeAllWindows
"
	self allInstances do:[:each| each close].! !

!LumiereWindow methodsFor: 'accessing' stamp: 'FernandoOlivero 8/28/2009 12:08'!
addClickingOnShapes 
	drawable addClickingOnShapes  ! !

!LumiereWindow methodsFor: 'accessing' stamp: 'FernandoOlivero 8/28/2009 12:08'!
addFloatingOverAwareness  
	drawable addFloatingOverAwareness ! !

!LumiereWindow methodsFor: 'accessing' stamp: 'FernandoOlivero 8/28/2009 12:09'!
addKeyboardNavigation   
	drawable addKeyboardNavigation ! !

!LumiereWindow methodsFor: 'toolbar' stamp: 'FernandoOlivero 10/18/2009 16:59'!
cameraToolbarItem
	^ self 
		newButtonFor: drawable  
		getState: nil
		action: #openCameraMorph
		arguments: nil
		getEnabled: nil
		labelForm: MenuIcons smallUpdateIcon 
		help: 'Manipulate Camera' translated.
	! !

!LumiereWindow methodsFor: 'accessing' stamp: 'F Olivero 4/2/2009 13:32'!
close
	self delete.
	! !

!LumiereWindow methodsFor: 'accessing' stamp: 'FernandoOlivero 8/28/2009 12:13'!
delete
	drawable notNil ifTrue:[ drawable delete ].
	super delete
	! !

!LumiereWindow methodsFor: 'initialize-release' stamp: 'FernandoOlivero 10/13/2009 18:14'!
drawable: aDrawable 
	drawable := aDrawable.
	self
		addMorphFront: drawable;
		initializeToolbar ;
		bounds: aDrawable bounds.! !

!LumiereWindow methodsFor: 'private' stamp: 'F Olivero 6/22/2009 21:21'!
drawableBounds
	| margin origin translation |
	margin := self margin.
	translation := margin@(margin*2).
	origin := self bounds origin + translation.
	^ origin extent:  self bounds extent - ( margin+margin @ ( margin * 4 ) ).
	! !

!LumiereWindow methodsFor: 'accessing' stamp: 'F Olivero 4/30/2009 11:31'!
extent: aPoint
	super extent: aPoint.
	self resize.! !

!LumiereWindow methodsFor: 'private' stamp: 'FernandoOlivero 10/13/2009 17:52'!
hasDrawable
	^ drawable notNil ! !

!LumiereWindow methodsFor: 'initialize-release' stamp: 'FernandoOlivero 10/13/2009 18:14'!
initialize
	super initialize.
	self title: self windowTitle ! !

!LumiereWindow methodsFor: 'toolbar' stamp: 'FernandoOlivero 10/18/2009 17:23'!
initializeToolbar
	| dock tools |
	tools := self newToolbar: {
		self toogleAxesToolbarItem.
		self viewportToolbarItem.
		self viewingVolumeToolbarItem.
		self cameraToolbarItem.
		self shapeBuilderToolbarItem.
		self layoutBuilderToolbarItem  }. 
	owner := nil.
	dock := self  newToolDockingBar.
	dock addMorphBack: tools.
	self 
			addMorph: dock
			fullFrame: (LayoutFrame fractions: (0@0 corner: 1@0) offsets: (0@0 corner: 0 @ dock minExtent y)).
		self  themeChanged.! !

!LumiereWindow methodsFor: 'toolbar' stamp: 'FernandoOlivero 10/18/2009 17:28'!
layoutBuilderToolbarItem
	^ self 
		newButtonFor: drawable  
		getState: nil
		action: #openLayoutBuilderMorph
		arguments: nil
		getEnabled: nil
		labelForm: MenuIcons smallCenteredIcon   
		help: 'Apply a layout to the microworld' translated! !

!LumiereWindow methodsFor: 'private' stamp: 'FernandoOlivero 10/12/2009 15:04'!
margin
	^ 25! !

!LumiereWindow methodsFor: 'initialize-release' stamp: 'FernandoOlivero 10/12/2009 16:19'!
openViewingVolumeMorphButton 
	self
		newButtonFor: self 
		getState: nil
		action: #openViewingVolumeMorph
		arguments: nil
		getEnabled: nil
		labelForm: MenuIcons smallOpenIcon
		help: 'Open viewing volume morph'! !

!LumiereWindow methodsFor: 'accessing' stamp: 'FernandoOlivero 10/13/2009 17:53'!
position: aPoint
	super position: aPoint.
	self hasDrawable ifTrue:[
		drawable position: aPoint + (self margin@(self margin*3)).
		self update ]! !

!LumiereWindow methodsFor: 'accessing' stamp: 'FernandoOlivero 8/31/2009 00:31'!
removeWindow
	self removeMorph: drawable.
	drawable update.
	drawable := nil.
	self delete.
	! !

!LumiereWindow methodsFor: 'private' stamp: 'FernandoOlivero 10/13/2009 17:53'!
resize
	self hasDrawable ifTrue:[ drawable bounds: self drawableBounds ].

	! !

!LumiereWindow methodsFor: 'toolbar' stamp: 'FernandoOlivero 10/18/2009 14:09'!
shapeBuilderToolbarItem
	^ self 
		newButtonFor: drawable  
		getState: nil
		action: #openShapeBuilderMorph
		arguments: nil
		getEnabled: nil
		labelForm: MenuIcons smallProjectIcon  
		help: 'Build a composite shape' translated! !

!LumiereWindow methodsFor: 'accessing' stamp: 'F Olivero 5/14/2009 00:05'!
stageMorph
	^ drawable ! !

!LumiereWindow methodsFor: 'toolbar' stamp: 'FernandoOlivero 10/18/2009 17:28'!
toogleAxesToolbarItem
	^ self 
		newButtonFor: drawable  
		getState: nil
		action: #toogleAxes
		arguments: nil
		getEnabled: nil
		labelForm: MenuIcons smallHelpIcon
		help: 'Toogle Axes' translated! !

!LumiereWindow methodsFor: 'updating' stamp: 'FernandoOlivero 10/13/2009 17:53'!
update
	self hasDrawable ifTrue:[ drawable update ]! !

!LumiereWindow methodsFor: 'toolbar' stamp: 'FernandoOlivero 10/18/2009 16:59'!
viewingVolumeToolbarItem
	^ self 
		newButtonFor: drawable  
		getState: nil
		action: #openViewingVolumeMorph
		arguments: nil
		getEnabled: nil
		labelForm: MenuIcons  smallConfigurationIcon
		help: 'Manipulate Viewing Volume' translated.
	! !

!LumiereWindow methodsFor: 'toolbar' stamp: 'FernandoOlivero 10/18/2009 14:09'!
viewportToolbarItem
	^ self 
		newButtonFor: drawable  
		getState: nil
		action: #openViewportMorph
		arguments: nil
		getEnabled: nil
		labelForm: MenuIcons smallSelectIcon  
		help: 'Manipulate Viewport' translated! !

!LumiereWindow methodsFor: 'private' stamp: 'F Olivero 5/5/2009 20:55'!
windowTitle
	^ 'Lumiere window'! !

Announcement subclass: #LStageAnnouncement
	instanceVariableNames: 'shape stage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Lumiere-Morphic'!

!LStageAnnouncement methodsFor: 'accessing' stamp: 'F Olivero 8/10/2009 23:35'!
shape 
	^ shape ! !

!LStageAnnouncement methodsFor: 'accessing' stamp: 'F Olivero 8/10/2009 23:35'!
shape: aLShape 
	shape := aLShape.! !

!LStageAnnouncement methodsFor: 'accessing' stamp: 'F Olivero 8/10/2009 23:35'!
stage 
	^ stage ! !

!LStageAnnouncement methodsFor: 'accessing' stamp: 'F Olivero 8/10/2009 23:35'!
stage: aLStage 
	stage := aLStage ! !

LStageAnnouncement subclass: #LStageMorphClose
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Lumiere-Morphic'!

LStageAnnouncement subclass: #LStageShapeClicked
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Lumiere-Morphic'!

LStageAnnouncement subclass: #LStageShapeDeletion
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Lumiere-Morphic'!

LStageAnnouncement subclass: #LStageShapeHighlight
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Lumiere-Morphic'!

LStageAnnouncement subclass: #LStageShapeSelection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Lumiere-Morphic'!

LStageShapeSelection subclass: #LStageShapeDeselection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Lumiere-Morphic'!
